import * as React from "react";
import { IModel, IModelData, IQueryBuilder, IQueryManager, IQueryParams } from "redux-data-service";
import { Omit } from "redux-data-service/dist/Omit";
export interface IInfiniteScrollProps<T extends IModelData> {
    modelName: string;
    query: IQueryParams | IQueryBuilder;
    containerComponent: React.ComponentType<{
        onScroll: React.UIEventHandler;
    } & any>;
    modelComponent: React.ComponentType<{
        model: T;
    } & any>;
    modelComponentProps?: any;
    debounceTime?: number;
    disableVirtualScrolling?: boolean;
    contentPlaceHolderComponent?: React.ComponentType<{
        height: number;
    }>;
    [key: string]: any;
}
export interface IInfiniteScrollHeightMapProps {
    pageHeightMap: {
        [key: string]: number;
    };
    estimatedPageHeight: number;
}
export interface IInfiniteScrollInternalProps<T extends IModel<IModelData>> extends Omit<IInfiniteScrollProps<any>, "query">, IInfiniteScrollHeightMapProps {
    query: IQueryManager<T>;
    updatePageHeightMap: (query: IQueryManager<any>) => any;
    updateQuery: (queryBuilder: IQueryBuilder) => void;
    lastScrollTop: number;
    currentPageHeightRef: React.RefObject<any>;
    previousPageHeightRef: React.RefObject<any>;
    nextPageHeightRef: React.RefObject<any>;
    handleScrollDebounced: (e: any) => void;
    handleScrollThrottled: (e: any) => void;
    handleScrollPersistingEvent: (e: any) => void;
    previousPlaceHolderHeight: number;
    nextPlaceHolderHeight: number;
}
export interface IDisplayPreviousPageProps<T extends IModelData> {
    modelName: string;
    queryManager: IQueryManager<T>;
    modelComponent: React.ComponentType<{
        model: T;
    } & any>;
    modelComponentProps?: any;
}
export declare const InfiniteScroll: React.ComponentClass<IInfiniteScrollProps<any>>;
