"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var redux_data_service_1 = require("redux-data-service");
function seedServiceListWithPagingOptions(serviceName, pageSize, totalPages) {
    var firstPageQueryOptions = {
        queryParams: { page: 1 },
        pageSize: pageSize,
        totalCount: pageSize,
        hasNext: true,
        nextPage: 2,
        hasPrevious: false,
        currentPage: 1,
        totalPages: totalPages,
    };
    var lastPageQueryOptions = {
        queryParams: { page: totalPages },
        pageSize: pageSize,
        totalCount: pageSize,
        hasNext: false,
        hasPrevious: true,
        previousPage: totalPages - 1,
        currentPage: totalPages,
        totalPages: totalPages,
    };
    redux_data_service_1.seedServiceList(serviceName, pageSize, { fullText: "page1" }, firstPageQueryOptions);
    redux_data_service_1.seedServiceList(serviceName, pageSize, { fullText: "page" + totalPages }, lastPageQueryOptions);
    for (var i = 2; i < totalPages; i++) {
        redux_data_service_1.seedServiceList(serviceName, pageSize, { fullText: "page" + i }, {
            queryParams: { page: i },
            pageSize: pageSize,
            totalCount: pageSize,
            hasNext: true,
            nextPage: i + 1,
            hasPrevious: true,
            previousPage: i - 1,
            currentPage: i,
            totalPages: totalPages,
        });
    }
}
exports.seedServiceListWithPagingOptions = seedServiceListWithPagingOptions;
