"use strict";
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var recompose_1 = require("recompose");
var redux_data_service_1 = require("redux-data-service");
var WithModel_1 = require("./WithModel");
function withNewModel(options) {
    return recompose_1.compose(recompose_1.defaultProps(__assign({ idPropKey: "id", modelPropKey: "model" }, options)), recompose_1.lifecycle({
        componentDidMount: function () {
            var _a;
            var _b = this.props, idPropKey = _b.idPropKey, modelPropKey = _b.modelPropKey, modelName = _b.modelName;
            if (!this.props[idPropKey] && !this.props[modelPropKey]) {
                var model = redux_data_service_1.getDataService(modelName).createNew();
                this.setState((_a = {}, _a[idPropKey] = model.id, _a));
            }
        },
        componentWillUnmount: function () {
            var modelPropKey = this.props.modelPropKey;
            var model = this.props[modelPropKey];
            if (model && model.isNew) {
                model.unload();
            }
        },
    }), WithModel_1.withModel(options));
}
exports.withNewModel = withNewModel;
